=== added file 'lava_dispatcher/default-config/lava-dispatcher/device-types/k3v2.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/k3v2.conf	1970-01-01 00:00:00 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/k3v2.conf	2013-06-10 20:26:18 +0000
@@ -0,0 +1,46 @@
+client_type = k3v2
+
+# The ADB command line.
+#
+# In the case where there are multiple android devices plugged into a
+# single host, this connection command must be overriden on each device to
+# include the serial number of the device, e.g.
+#
+#   serial_number = XXXXXXXXXXXXXXXX
+#   adb_command = adb -s %(serial_number)s
+adb_command = adb
+
+# The fastboot command.
+#
+# The same as above: if you have more than one device, you will want to
+# override this in your device config to add a serial number, e.g.
+#
+#   serial_number = XXXXXXXXXXXXXXXX
+#   fastboot_command = fastboot -s %(serial_number)s
+#
+# Of course, in the case you override both adb_command *and* fastboot_command,
+# you don't need to specify `serial_number` twice.
+fastboot_command = fastboot
+
+# Working directory for temporary files. By default, the usual place for LAVA
+# images will be used.
+#
+# This is useful when the lava dispatcher is controlling the device under test which is
+# physically plugged to other machines by setting adb_command to something like
+# "ssh <phone-host> adb" and fastboot_command to something like "ssh
+# <phone-host> fastboot". adb and fastboot always operate on local files, so
+# you need your local files to also be seen as local files on the host where
+# adb/fastboot are executed.
+#
+# In this case, you should set shared_working_directory to a shared directory
+# between the machine running the dispatcher and the machine where the phone is
+# plugged.  This shared directory must have the same path in both machines.
+# For example, you can have your /var/tmp/lava mounted at /var/tmp/lava at
+# <phone-host> (or the other way around).
+shared_working_directory =
+
+connection_command = %(adb_command)s shell
+
+enable_network_after_boot_android = false
+android_adb_over_usb = true
+android_adb_over_tcp = false

=== added file 'lava_dispatcher/device/k3v2.py'
--- lava_dispatcher/device/k3v2.py	1970-01-01 00:00:00 +0000
+++ lava_dispatcher/device/k3v2.py	2013-06-11 15:43:17 +0000
@@ -0,0 +1,75 @@
+# Copyright (C) 2013 Linaro Limited
+#
+# Author: Tyler Baker <Tyler.Baker@linaro.org>
+#
+# This file is part of LAVA Dispatcher.
+#
+# LAVA Dispatcher is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# LAVA Dispatcher is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along
+# with this program; if not, see <http://www.gnu.org/licenses>.
+
+from time import sleep
+from lava_dispatcher.device.target import (
+    Target
+)
+from lava_dispatcher.device.fastboot import (
+    FastbootTarget
+)
+from lava_dispatcher.utils import (
+    connect_to_serial,
+)
+
+class K3V2Target(FastbootTarget):
+
+    def __init__(self, context, config):
+        super(K3V2Target, self).__init__(context, config)
+
+    def deploy_android(self, boot, system, userdata):
+
+        boot = self._get_image(boot)
+        system = self._get_image(system)
+        userdata = self._get_image(userdata)
+
+        self.fastboot.enter()
+        # Need to sleep and wait for the first stage bootloaders to initialize. 
+        sleep(10)
+        self.fastboot.flash('boot', boot)
+        self.fastboot.flash('system', system)
+        self.fastboot.flash('userdata', userdata)
+
+        self.deployment_data = Target.android_deployment_data
+        self.deployment_data['boot_image'] = boot
+
+    def power_on(self):
+        if not self.deployment_data.get('boot_image', False):
+            raise CriticalError('Deploy action must be run first')
+
+        # The k3v2 does not implement booting kernel from ram.
+        # So instead we must flash the boot image, and reboot.
+        self.fastboot.enter()
+        self.fastboot('reboot')
+        proc = connect_to_serial(self.context)
+        proc.expect(self.context.device_config.master_str,
+                          timeout=300)
+
+        # The k3v2 does not yet have adb support, so we do not wait for adb.
+        #self._adb('wait-for-device')
+
+        self._booted = True
+        proc.sendline("") # required to put the adb shell in a reasonable state
+        proc.sendline("export PS1='%s'" % self.deployment_data['TESTER_PS1'])
+        self._runner = self._get_runner(proc)
+
+        return proc
+
+target_class = K3V2Target