=== modified file 'lava_dispatcher/default-config/lava-dispatcher/device-types/arndale-uefi.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/arndale-uefi.conf	2013-04-17 09:33:07 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/arndale-uefi.conf	2013-08-14 21:48:44 +0000
@@ -46,3 +46,9 @@
 sdcard_part_android = 7
 data_part_android = 7
 
+boot_options =
+    boot_cmds
+
+[boot_cmds]
+default = boot_cmds
+

=== modified file 'lava_dispatcher/default-config/lava-dispatcher/device-types/arndale.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/arndale.conf	2013-08-14 20:57:02 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/arndale.conf	2013-08-14 21:48:44 +0000
@@ -4,7 +4,7 @@
 testboot_offset = 3
 
 boot_cmds = mmc rescan,
-    mmc part 1,
+    mmc part 0,
     setenv bootcmd "'fatload mmc 0:5 0x40007000 uImage; fatload mmc 0:5 0x42000000 uInitrd; fatload mmc 0:5 0x41f00000 board.dtb; bootm 0x40007000 0x42000000 0x41f00000'",
     setenv bootargs "'console=ttySAC2,115200n8  root=LABEL=testrootfs rootwait ro'",
     boot
@@ -45,3 +45,9 @@
 
 bootloader_prompt = ARNDALE5250
 
+boot_options =
+    boot_cmds
+
+[boot_cmds]
+default = boot_cmds
+

=== modified file 'lava_dispatcher/default-config/lava-dispatcher/device-types/beagle-xm.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/beagle-xm.conf	2013-08-12 20:44:14 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/beagle-xm.conf	2013-08-14 21:48:44 +0000
@@ -22,3 +22,9 @@
 
 qemu_machine_type = beaglexm
 lmc_dev_arg = beagle
+
+boot_options =
+    boot_cmds
+
+[boot_cmds]
+default = boot_cmds

=== modified file 'lava_dispatcher/default-config/lava-dispatcher/device-types/mx51evk.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/mx51evk.conf	2013-08-12 20:44:14 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/mx51evk.conf	2013-08-14 21:48:44 +0000
@@ -10,3 +10,9 @@
     root=LABEL=testrootfs rootwait ro'",
     boot
 bootloader_prompt = >
+
+boot_options =
+    boot_cmds
+
+[boot_cmds]
+default = boot_cmds

=== modified file 'lava_dispatcher/default-config/lava-dispatcher/device-types/mx53loco.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/mx53loco.conf	2013-08-12 20:44:14 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/mx53loco.conf	2013-08-14 21:48:44 +0000
@@ -29,3 +29,9 @@
     init=/init androidboot.console=ttymxc0'",
     boot
 bootloader_prompt = >
+
+boot_options =
+    boot_cmds
+
+[boot_cmds]
+default = boot_cmds

=== modified file 'lava_dispatcher/default-config/lava-dispatcher/device-types/origen.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/origen.conf	2013-08-12 20:44:14 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/origen.conf	2013-08-14 21:48:44 +0000
@@ -28,3 +28,9 @@
 bootloader_prompt = #
 
 lmc_dev_arg = origen
+
+boot_options =
+    boot_cmds
+
+[boot_cmds]
+default = boot_cmds

=== modified file 'lava_dispatcher/default-config/lava-dispatcher/device-types/panda.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/panda.conf	2013-08-14 20:57:02 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/panda.conf	2013-08-14 21:48:44 +0000
@@ -59,3 +59,9 @@
 
 # changed to /mnt/sdcard in  http://review.android.git.linaro.org/#change,3213
 sdcard_mountpoint_path = /mnt/sdcard
+
+boot_options =
+    boot_cmds
+
+[boot_cmds]
+default = boot_cmds

=== modified file 'lava_dispatcher/default-config/lava-dispatcher/device-types/snowball.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/snowball.conf	2013-08-12 20:44:14 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/snowball.conf	2013-08-14 21:48:44 +0000
@@ -25,3 +25,9 @@
 
 android_orig_block_device = mmcblk0
 android_lava_block_device = mmcblk0
+
+boot_options =
+    boot_cmds
+
+[boot_cmds]
+default = boot_cmds

=== modified file 'lava_dispatcher/default-config/lava-dispatcher/device-types/vexpress-tc2.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/vexpress-tc2.conf	2013-05-23 11:08:00 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/vexpress-tc2.conf	2013-08-14 21:48:44 +0000
@@ -33,4 +33,10 @@
 partition_padding_string_android =
 sys_part_android = 1
 sdcard_part_android = 3
-data_part_android = 2
\ No newline at end of file
+data_part_android = 2
+
+boot_options =
+    boot_cmds
+
+[boot_cmds]
+default = boot_cmds

=== modified file 'lava_dispatcher/default-config/lava-dispatcher/device-types/vexpress.conf'
--- lava_dispatcher/default-config/lava-dispatcher/device-types/vexpress.conf	2013-05-02 22:28:25 +0000
+++ lava_dispatcher/default-config/lava-dispatcher/device-types/vexpress.conf	2013-08-14 21:48:44 +0000
@@ -15,3 +15,9 @@
     fstab.arm-versatileexpress
 
 read_boot_cmds_from_image = 0
+
+boot_options =
+    boot_cmds
+
+[boot_cmds]
+default = boot_cmds